<?php
/*                                                       */
/* sendmail.php - Send an answer mail                    */
/* $ID 130 - 2024-03-24 - brom $                         */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */

require('../../config/config.php');
require_once(BC_PATH.'/lib/classes/class.admin.php');
$admin = new admin('Mailbox','mailbox','system');
$mbox=$admin->get_post('mbox');
$folder=$admin->get_post('folder');
$id=$admin->get_post('id');
$backlink = ADMIN_URL.'/mailbox/';
$caltab = '';
$body = $admin->get_post('body');
//$body = (empty($body)?$_SESSION['SENDMAIL']['BODY']:$body);
$mailto = $admin->get_post_escaped('mailto');
$mailtocc = $admin->get_post_escaped('mailtocc');
$subject = $admin->get_post_escaped('subject');
$covid = $admin->get_post('covid');
$currtpl = ((isset($_POST['currtpl']) AND is_numeric($_POST['currtpl']))?$admin->get_post('currtpl'):0);
$_SESSION['SENDMAIL']['TO']=$mailto;
$_SESSION['SENDMAIL']['CC']=$mailtocc;
$_SESSION['SENDMAIL']['SUBJECT']=$subject;
if(NULL !== $covid){ $_SESSION['SENDMAIL']['COVID'] = $covid; }
// Check is BelCal
if(file_exists(BC_PATH.'/modules/calendar/info.php')){
  $isbelcal = true;
  if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')){
    require(BC_PATH .'/modules/calendar/languages/EN.php');
  }
  else {
    require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
  }
  // check if calendar language file exists for the language set by the user
  if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
    require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
  }
}else{ $isbelcal = false; }
if(isset($_POST['tobody'])){
  if($id > 0){
    $backlink .= 'mailaction.php?mbox='.$mbox.ARGSOJS.'folder='.$folder.ARGSOJS.'id='.$id.ARGSOJS.'answer=1'.($currtpl > 0?ARGSOJS.'templ_id='.$currtpl:'');
  }
  else{
    $backlink .= 'mailaction.php?mbox='.$mbox.ARGSOJS.'folder='.$folder.ARGSOJS.'id=0'.ARGSOJS.'newmail=1'.($currtpl > 0?ARGSOJS.'templ_id='.$currtpl:'');
  }
  // Put the calendar data to email body
  $calobjects = array();
  $get_calobj = $datapdo->query("SELECT `object_id`,`active` FROM `".TABLE_PREFIX."sections` WHERE `module`='calendar' AND `active`>'0'");
  while($obj = $datapdo->fetchRow($get_calobj)){
    array_push($calobjects,$obj['object_id']);
  }
  $havechecked = false;
  // Check first one of the calobjects is checked
  foreach($calobjects AS $k => $v){
    if(isset($_POST['check_'.$v])){ $havechecked = true; break; }
  }
  $res_start = $admin->get_post('res_start');
  $res_end = $admin->get_post('res_end');
  $persons = $admin->get_post('persons');
  $children = $admin->get_post('children');
  $toddler = $admin->get_post('toddler');
  $date_days = $admin->get_post('days_anz');
  $_SESSION['CALDATA']['RES_START']=$res_start;
  $_SESSION['CALDATA']['RES_END']=$res_end;
  $_SESSION['CALDATA']['PERSONS']=$persons;
  $_SESSION['CALDATA']['CHILDREN']=$children;
  $_SESSION['CALDATA']['TODDLER']=$toddler;
  $_SESSION['CALDATA']['DATE_DAYS']=$date_days;
  if($havechecked==true){
    require_once(BC_PATH.'/lib/functions.php');
    $caltab .= '<p>'.$TEXT['TERMIN_START'].': '.$res_start.' / '.$TEXT['TERMIN_END'].': '.$res_end.'<br />';
    $caltab .= $persons.' '.$CALTEXT['PERSONS'].($children>0?' / '.$children.' '.$CALTEXT['CHILDREN']:'').($toddler>0?' / '.$toddler.' '.$CALTEXT['TODDLER']:'').'</p>'."\n";
    $caltab .= '<table cellspacing="0" cellpadding="2" width="90%" border="0">'."\n";
    $backgroundline = '#dddddd';
    foreach($calobjects AS $k => $v){
      $_SESSION['CALDATA']['ALLOBJECTS'][$v]['active']=0;
      if(isset($_POST['check_'.$v])){
        $backgroundline = ($backgroundline =='#eeeeee'?'#dddddd':'#eeeeee');
        $_SESSION['CALDATA']['ALLOBJECTS'][$v]['active']=1;
        if(isset($_POST['url_'.$v]) AND !empty($_POST['url_'.$v])){
          $url1 = $admin->get_post_escaped('url_'.$v);
        }
        else{ $url1 = ''; }
        $link = $datapdo->get_one("SELECT `link` FROM `".TABLE_PREFIX."objects` WHERE `object_id`='$v' LIMIT 1");
        $url2 = BC_DOMAIN.$admin->object_link($link);
        $url = $url1;
        if($url1 != $url2 AND $admin->validate_domain($url1)==true){
          // Update the url in object
          $datapdo->query("UPDATE `".TABLE_PREFIX."objects` SET `reflink`='$url1' WHERE `object_id`='$v' LIMIT 1");
          $url = $url1;
        }
        if($url1=='0' OR strtolower($url1)=='false'){ $url = ''; }
        else{ $url = ($url1 != ''?$url1:$url2); }
        $_SESSION['CALDATA']['ALLOBJECTS'][$v]['url']=$url;
        if(isset($_POST['specials1_'.$v]) AND !empty($_POST['specials1_'.$v])){ $area = $admin->get_post_escaped('specials1_'.$v); }
        else{ $area = 0; }
        if(isset($_POST['specials2_'.$v]) AND !empty($_POST['specials2_'.$v])){ $rooms = $admin->get_post_escaped('specials2_'.$v); }
        else{ $rooms = 0; }
        if(isset($_POST['specials3_'.$v]) AND !empty($_POST['specials3_'.$v])){ $location = $admin->get_post_escaped('specials3_'.$v); }
        else{ $location = ''; }
        if(isset($_POST['specials4_'.$v]) AND !empty($_POST['specials4_'.$v])){ $specials = $admin->get_post('specials4_'.$v); }
        else{ $specials = ''; }
        // Update the object like inputs
        $datapdo->query("UPDATE `".TABLE_PREFIX."objects` SET `area`='$area',`rooms`='$rooms' WHERE `object_id`='$v' LIMIT 1");
        $datapdo->query("UPDATE `".TABLE_PREFIX."obj_texts` SET `location`='$location',`specials`='$specials' WHERE `object_id`='$v' AND `language`='".LANGUAGE."' LIMIT 1");
        $specialline = ($area > 0?$TEXT['AREA'].': '.$area.' m&sup2;':'');
        if($rooms > 0){
          if($rooms == 1){ $roomstext = $TEXT['ROOM1']; }
          elseif($rooms == 2){ $roomstext = $TEXT['ROOM2']; }
          else{ $roomstext = $TEXT['ROOMS']; }
          $specialline .= (!empty($specialline)?' - ':'').$rooms.' '.$roomstext;
        }
        if(!empty($location)){
          $specialline .= (!empty($specialline)?' - ':'').$TEXT['LOCATION'].': '.$location;
        }
        if(!empty($specials)){
          $specialline .= (!empty($specialline)?'<br />':'').$specials;
        }
        $title = get_object_title($v);
        $price = $admin->get_post('price_'.$v);
        $get_calsettings = $datapdo->query("SELECT `section_id`,`countalldays` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$v' LIMIT 1");
        $calsettings = $datapdo->fetchRow($get_calsettings);
        $sectid = $calsettings['section_id'];
        $plusd = $calsettings['countalldays'];
        $incadds = '';
        $punit = $datapdo->get_one("SELECT `p_unit` FROM `".TABLE_PREFIX."res_price_sets` WHERE `section_id`='$sectid' LIMIT 1");
        $get_adds = $datapdo->query("SELECT `adds_name` FROM `".TABLE_PREFIX."res_price_adds` WHERE `section_id`='$sectid'");
        while($adds = $datapdo->fetchRow($get_adds)){
          $addsnames = unserialize($adds['adds_name']);
          if(count($addsnames)>0){
            if(!empty($addsnames[DEFAULT_LANGUAGE])){
              $incadds .= (empty($incadds)?$CALTEXT['INCLUSIVE'].' ':', ').$addsnames[DEFAULT_LANGUAGE];
            }
          }
        }
        $moreadds = '';
        if(isset($_SESSION['CALDATA']['ALLOBJECTS'][$v]['MORE'])){
          foreach($_SESSION['CALDATA']['ALLOBJECTS'][$v]['MORE'] AS $moreK => $moreV){
            if(!empty($moreV)){
              $moreadds .= ', '.$moreV;
            }
          }
        }
        $outimage = '';
        if($_SESSION['CALDATA']['ALLOBJECTS'][$v]['obj_image']!=''){
          $outimage = '<img src="'.$_SESSION['CALDATA']['ALLOBJECTS'][$v]['obj_image'].'" style="width:90%;" />';
        }
        if($admin->validate_domain($url)){ $urloutput = '<a href="'.$url.'">'.$title.'</a>'; }
        else{ $urloutput = '<b>'.$title.'</b>'; }
        $caltab .= '<tr style="background:'.$backgroundline.';">';
        if($outimage != ''){
          $caltab .= '<td style="width:15%;">'.$outimage.'</td><td style="vertical-align:top;">'.$urloutput.' ('.($date_days+$plusd).' '.($plusd>0?$TEXT['TERMIN_ANZ']:$TEXT['TERMIN_ANZN']).(($incadds.$moreadds)==''?'':' - ').$incadds.$moreadds.')'.(!empty($specialline)?'<br />'.$specialline:'').'</td><td style="width:15%;vertical-align:top;text-align:right;font-weight:bold;">'.$price.'&nbsp;'.(isset($TEXT['PRICE_UNIT'][$punit])?$TEXT['PRICE_UNIT'][$punit]:$punit).'</td>';
        }
        else{
          $caltab .= '<td colspan="2" style="vertical-align:top;">'.$urloutput.' ('.($date_days+$plusd).' '.($plusd>0?$TEXT['TERMIN_ANZ']:$TEXT['TERMIN_ANZN']).(($incadds.$moreadds)==''?'':' - ').$incadds.$moreadds.')'.(!empty($specialline)?'<br />'.$specialline:'').'</td><td style="width:15%;vertical-align:top;text-align:right;font-weight:bold;">'.$price.'&nbsp;'.(isset($TEXT['PRICE_UNIT'][$punit])?$TEXT['PRICE_UNIT'][$punit]:$punit).'</td>';
        }
        $caltab .= '</tr>'."\n";
      }
    }
    $caltab .= '</table>'."\n";
  }
  if(!empty($caltab)){
    // fill the caltab into body
    $pattern = '@(<div id=\"offers\">)(.*)(<\/div>)@Uis';
    $replacement = '$1'.$caltab.'$3';
    $body = preg_replace($pattern,$replacement,$body);
  }
  $_SESSION['SENDMAIL']['BODY']=$body;
  $admin->print_success('',$backlink,0.5);
}
else{
  require_once(BC_PATH.'/lib/functions.php');
  $get_mbox = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."mailboxes` WHERE `mailbox_id`='$mbox' LIMIT 1");
  $box = $datapdo->fetchRow($get_mbox);
  $mailbox = $box['position']-1;
  $pass = $admin->get_cryption($box['password'],$box['imapuser'],true);
  $sentfolder = $box['sentfolder'];
  $backlink .= 'index.php?mailbox='.$mailbox.ARGSOJS.'folder='.$folder;
  $tomailline = $admin->get_post_escaped('mailtoto');
  $tomails = explode(',',$tomailline);
  $toccline = $admin->get_post_escaped('mailtocc');
  $toccmails = array();
  $toccmails = explode(',',$toccline);
  $tomail = '';
  $toccmail = '';
  foreach($tomails AS $entry){
    if(preg_match('/.*<(.*)>/Uis',$entry,$toarray)){ $toadd = $toarray[1]; }
    else{ $toadd = $entry; }
    // If is it the covid check the reservations this mail
    if(NULL != $covid AND $isbelcal == true AND $admin->get_permission('reservations_modify','system')){
      $get_reservations = $datapdo->query("SELECT `res_id`,`covidnotice` FROM `".TABLE_PREFIX."reservations` WHERE `mail`='$toadd' AND `covid`='0' AND `res_end`>'".time()."'");
      if($datapdo->numRows($get_reservations)>0){
        while($reservs = $datapdo->fetchRow($get_reservations,false)){
          $resid = $reservs['res_id'];
          $covidnotice = $reservs['covidnotice'];
          $covidnotice .= ($covidnotice!=''?"\n":"").convert_date(DATE_FORMAT,time()).' - '.$CALTEXT['COVID1'];
          $datapdo->query("UPDATE `".TABLE_PREFIX."reservations` SET `covid`='1',`covidnotice`='$covidnotice' WHERE `res_id`='$resid' LIMIT 1");
        }
      }
    }
    $tomail .= (!empty($tomail)?',':'').$toadd;
  }
  if(count($toccmails)>0){
    foreach($toccmails AS $entry){
      if(preg_match('/.*<(.*)>/Uis',$entry,$toarray)){ $toadd = $toarray[1]; }
      else{ $toadd = $entry; }
      $tomail .= (!empty($tomail)?',':'').$toadd;
    }
  }
  $frommail = $admin->get_post('sendermail');
  $confirmReadMail = '';
  if(isset($_POST['confirmRead']) AND $admin->get_post_escaped('confirmRead')==1){
    $confirmReadMail = $frommail;
    $_SESSION['SENDMAIL']['CONFIRMREAD']=1;
  }
  else{ $_SESSION['SENDMAIL']['CONFIRMREAD']=0; }
  $fromname = $box['boxname'];
//  $fromname = (empty($fromname)?$admin->get_display_name():$fromname);
  $subject = $admin->get_post_escaped('subject');
  $message = $admin->get_post('body');
  $pattern = '/src=\"[^(https?)](.*\")/';
  $repl = 'src="'.BC_DOMAIN.'/$1';
  $message = preg_replace($pattern,$repl,$message);

  $admin->preprocess($message,true);
  $attachments = array();
  //Here we build attachments if available
  for($count = 1; $count <= 5; $count++) {
    if(isset($_FILES["att$count"]["name"])){
      $attfilename = $_FILES["att$count"]["name"];
      // Be shure the attachment folder exists
      @make_dir(BC_PATH.'/temp/attachfiles');
      $file_temp = BC_PATH.'/temp/attachfiles/'.$attfilename;
      if(move_uploaded_file($_FILES["att$count"]["tmp_name"], $file_temp)){
        $attachments[] = array($file_temp,$attfilename);
      }
    }
  }
  $errormsg = '';
  $result = $admin->mail($frommail, $tomail, $subject, $message, $fromname, 'html', $attachments, true, $confirmReadMail);
  if($result == false){ $errormsg = '<br />'.$MESSAGE['MAILBOX']['SENDERROR']; }
  require_once(BC_PATH.'/lib/classes/class.imap.php');
  $imapS = new imap($box['imapserver'],$box['imapport'],$box['imapuser'],$pass,$box['imaptype'],$sentfolder);
  if(isset($_POST['uid']) AND is_numeric($_POST['uid'])){
    $currfolder = $folder;
    $olduid = $admin->get_post('uid');
  // Set the old mail to answered
//  if($oldemail = $imap->getMailMsg($id,false)){
//    $oldemail = $imapS->getMailMsg($id,false);
//    $olduid = $oldemail['uid'];
    $imapS->setAnsweredMailMsg($olduid,true,$currfolder);
  }
  $insent = $imapS->saveMailMsgInSent($result);
  $imapS = NULL;
  if($insent == false){ $errormsg .= '<br />'.$MESSAGE['MAILBOX']['SAVEERROR']; }
  if(!empty($errormsg)){ $admin->print_error($TEXT['ERROR'].':'.$errormsg,$backlink); }
  else{
    if(isset($_SESSION['CALDATA'])){ unset($_SESSION['CALDATA']); }
    unset($_SESSION['SENDMAIL']);
    $admin->print_success($TEXT['SUCCESS'],$backlink);
  }
}

// Print admin footer
$admin->print_footer();
?>